function [x2, i] = newton(f, df, x0, delta, N)
% Az eljrs a newton mdszer segtsgvel hatrozza meg egy egy vltozs 
% nemlineris egyenlet megoldst
%
% Bemen paramterek:
%   f - egyvltozs fggvny
%   df - a fggvny derivltja
%   x0 - kezd rtk
%   delta - lellsi felttel, kzelts kszbrtke
%   N - lellsi felttel, maximlis iterc szm
%
% Kimenet:
%   x2 - a megolds helye
%   i - itercik szma

    x1 = x0;
    x2 = x1 - f(x1)/df(x1);
    i = 1;
    while abs(f(x2))>delta && i<=N
        x1 = x2;
        x2 = x1 - f(x1)/df(x1);
        i = i + 1;
    end
end